﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class AnimationBus : MonoBehaviour
{
    Engineer engineer;
    Manager manager;

    void Start()
    {
        engineer = transform.parent.GetComponent<Engineer>();
        manager = FindObjectOfType<Manager>();
    }

    public void RepairTower()
    {
        engineer.RepairTower();
    }

    public void ThrowHammer()
    {
        engineer.ThrowHammer();
    }

    public void StepSound()
    {
        AudioManager.PlaySound2D("Walking", 0.3f);
    }

    public void SpawnEnemy()
    {
        manager.SpawnEnemy();
    }
}
