﻿using UnityEngine;
using Mono.Data.Sqlite;
using System.Data;
using System.Collections.Generic;
using System;

public class DBManager : MonoBehaviour
{

    private string conn;
    private IDbConnection dbconn = null;
    private IDataReader reader = null;
    private IDbCommand dbcmd = null;

    private List<Playerscore> playerScoreList;

    private void Awake()
    {
        playerScoreList = new List<Playerscore>();
        conn = "URI=file:" + Application.dataPath + "/Plugins/GameDB.db";
    }

    public void Start()
    {
        dbconn = (IDbConnection) new SqliteConnection(conn);
    }

    // Insert into DB
    public void InsertNewHighscore(string name, int score)
    {
        // Check name
        if (name == "") name = "no name";

        dbconn = (IDbConnection)new SqliteConnection(conn);
        dbconn.Open(); //Open connection to the database
        dbcmd = dbconn.CreateCommand();

        Playerscore lastScore = GetLastHighscore();

        //string sql = "INSERT INTO highscore(name, score) VALUES('"+name+"', "+ score +")";
        // ' or IN ( INSERT INTO highscore(name, score) VALUES("Tek", 123123))

        if (score >= lastScore.Score)
        {
            dbconn = (IDbConnection)new SqliteConnection(conn);
            dbconn.Open(); //Open connection to the database
            dbcmd = dbconn.CreateCommand();

            string sql = "UPDATE highscore SET name='"+ name + "', score="+ score + " WHERE id="+ lastScore.Id;
            dbcmd.CommandText = sql;
            
            dbcmd.ExecuteNonQuery();
            
            dbcmd.Dispose();
            dbcmd = null;
            dbconn.Close();
            dbconn = null;
        }
    }

    // Check database Highscore
    private Playerscore GetLastHighscore()
    {
        dbconn = (IDbConnection)new SqliteConnection(conn);
        dbconn.Open(); //Open connection to the database
        dbcmd = dbconn.CreateCommand();

        string sqlQuery = "SELECT * FROM highscore ORDER BY score ASC LIMIT 1 ";
        dbcmd.CommandText = sqlQuery;
        reader = dbcmd.ExecuteReader();

        Playerscore playerscore = new Playerscore("", 0);

        while (reader.Read())
        {
            playerscore.Id = reader.GetInt32(0);
            playerscore.Name = reader.GetString(1);
            playerscore.Score = reader.GetInt32(2);
        }

        reader.Close();
        reader = null;
        dbcmd.Dispose();
        dbcmd = null;
        dbconn.Close();
        dbconn = null;

        return playerscore;
    }

    // Get from DB
    public List<Playerscore> GetHighscores()
    {
        playerScoreList.Clear();

        dbconn = (IDbConnection)new SqliteConnection(conn);
        dbconn.Open(); //Open connection to the database
        dbcmd = dbconn.CreateCommand();

        string sqlQuery = "SELECT * FROM highscore ORDER BY score DESC LIMIT 5 ";
        dbcmd.CommandText = sqlQuery;
        reader = dbcmd.ExecuteReader();

        while (reader.Read())
        {
            int value = reader.GetInt32(0);
            string name = reader.GetString(1);
            int score = reader.GetInt32(2);

            playerScoreList.Add(new Playerscore(name, score));
            Debug.Log("value= " + value + "  name =" + name + "  score =" + score);
        }

        reader.Close();
        reader = null;
        dbcmd.Dispose();
        dbcmd = null;
        dbconn.Close();
        dbconn = null;

        return playerScoreList;
    }
    
    
}
