﻿using System.Collections;
using System.Collections.Generic;
using TMPro;
using UnityEngine;
using UnityEngine.SceneManagement;

public class HUDManager : MonoBehaviour
{
    public TMP_InputField input;
    private Playerscore player;
    private DBManager db;

    TextMeshProUGUI scoreText;
    TextMeshProUGUI scoreTextLose;
    GameObject HUD;
    GameObject LosingHUD;

    void Start()
    {
        player = new Playerscore("",0);
        db = GameObject.FindGameObjectWithTag("DBManager").GetComponent<DBManager>();
        HUD = GameObject.FindGameObjectWithTag("HUD");
        scoreText = HUD.transform.GetChild(1).GetChild(0).GetComponent<TextMeshProUGUI>();
        scoreTextLose = HUD.transform.GetChild(0).GetChild(1).GetChild(1).GetComponent<TextMeshProUGUI>();
        LosingHUD = HUD.transform.GetChild(0).gameObject;
        LosingHUD.SetActive(false);
    }

    public void AddPoints(int points)
    {
        player.Score += points;
        scoreText.text = player.Score.ToString();
        scoreTextLose.text = player.Score.ToString();
    }

    public void SetName()
    {
        player.Name = input.text;
        ExitMainMenu();
    }

    public void ExitMainMenu()
    {
        db.InsertNewHighscore(player.Name, player.Score);
        SceneManager.LoadScene(0, LoadSceneMode.Single);
    }

    public void ShowLosingHUD()
    {
        LosingHUD.SetActive(true);
    }
}
