﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.AI;

public class Hammer : MonoBehaviour
{
    GameObject hammer;
    Collider hammerCollider;

    bool throwHammer;

    void Start()
    {
        hammer = transform.GetChild(0).gameObject;
        hammerCollider = GetComponent<Collider>();
    }
    
    void FixedUpdate()
    {
        if (throwHammer)
        {
            transform.Translate(new Vector3(0, -0.5f * Time.deltaTime, 15f * Time.deltaTime));
        }
    }

    public void HideHammer()
    {
        hammer.SetActive(false);
        hammerCollider.enabled = false;
    }

    public void ThrowHammer()
    {
        hammer.SetActive(true);
        hammer.transform.localRotation = Quaternion.Euler(-90, 0, 90);
        throwHammer = true;
        hammerCollider.enabled = true;
    }

    private void OnTriggerEnter(Collider other)
    {
        throwHammer = false;
        hammerCollider.enabled = false;
        if(NavMesh.SamplePosition(transform.position, out NavMeshHit hit, 100, -1))
        {
            transform.position = new Vector3(hit.position.x, hit.position.y + 0.21f, hit.position.z);
            hammer.transform.localRotation = Quaternion.Euler(0, 0, 90);
        }
        if (other.name.Contains("Enemy"))
        {
            other.GetComponent<Enemy>().Damage(200);
        }
    }
}
