﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Manager : MonoBehaviour
{
    public GameObject enemyPrefab;

    Transform spawner;
    Transform targetSpawner;
    float spawnTimer;

    bool startRun;

    Engineer engineer;

    Queue<ParticleSystem> explosionQueue;

    Animator spawnAnim;

    void Start()
    {
        spawner = transform.GetChild(0);
        targetSpawner = spawner.GetChild(0);
        engineer = FindObjectOfType<Engineer>();

        explosionQueue = new Queue<ParticleSystem>();
        Transform holder = transform.GetChild(2);
        for(int i=0; i < holder.childCount; i++)
        {
            explosionQueue.Enqueue(holder.GetChild(i).GetComponent<ParticleSystem>());
        }

        spawnAnim = transform.GetChild(3).GetComponent<Animator>();
    }
    
    void Update()
    {
        if(!engineer.IsEngineerDead())
            SpawnSystem();
    }

    void SpawnSystem()
    {
        spawnTimer -= Time.deltaTime;
        if (spawnTimer <= 0)
        {
            spawnTimer = Random.Range(2f, 8f);
            spawner.rotation = Quaternion.Euler(0, Random.Range(0, 360), 0);
            spawnAnim.gameObject.SetActive(false);
            spawnAnim.transform.position = targetSpawner.position;
            spawnAnim.gameObject.SetActive(true);
            spawnAnim.SetTrigger("Spawn");
        }
    }

    public void PlayExplosion(Vector3 position)
    {
        ParticleSystem ps = explosionQueue.Dequeue();
        ps.transform.position = position;
        ps.Play();
        explosionQueue.Enqueue(ps);
    }

    public void SpawnEnemy()
    {
        Instantiate(enemyPrefab, targetSpawner.position, Quaternion.identity);
        spawnAnim.SetTrigger("Wait");
    }
}
