﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.IO;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
using TMPro;

public class MenuManager : MonoBehaviour
{
    private GameObject Credits;
    private GameObject Leaderboard;
    private GameObject MainMenu;
    private GameObject ExitGamePopup;
    
    private DBManager db;

    private List<Playerscore> leaderBoard;
    private List<GameObject> leaderBoardObjects = new List<GameObject>();

    void Start()
    {
        MainMenu = transform.GetChild(0).GetChild(0).gameObject;
        Credits = transform.GetChild(0).GetChild(1).gameObject;
        Leaderboard = transform.GetChild(0).GetChild(2).gameObject;
        ExitGamePopup = transform.GetChild(0).GetChild(3).gameObject;

        Credits.SetActive(false);
        Leaderboard.SetActive(false);
        MainMenu.SetActive(true);
        ExitGamePopup.SetActive(false);

        db = GameObject.FindGameObjectWithTag("DBManager").GetComponent<DBManager>();
        db.Start();
        leaderBoard = new List<Playerscore>();
    }

    // Main Menu
    public void MainMenuOpen()
    {
        Credits.SetActive(false);
        Leaderboard.SetActive(false);
        MainMenu.SetActive(true);
        ExitGamePopup.SetActive(false);
    }

    // Play Game
    public void PlayGame()
    {
        Debug.Log("PlayButton");
        SceneManager.LoadScene(1, LoadSceneMode.Single);
    }

    // Settings
    public void CreditsMenu()
    {
        Debug.Log("Credits");
        Credits.SetActive(true);
        Leaderboard.SetActive(false);
        MainMenu.SetActive(false);
        ExitGamePopup.SetActive(false);
    }

    // Highscore
    public void LeaderboardMenu()
    {
        db.GetHighscores();
        Debug.Log("Leaderboard");
        Credits.SetActive(false);
        Leaderboard.SetActive(true);
        MainMenu.SetActive(false);
        ExitGamePopup.SetActive(false);
        LoadLeaderboard();
    }

    // Exit Game
    public void ExitGame()
    {
        Debug.Log("ExitGame");
        ExitGamePopup.SetActive(true);
        Application.Quit();
    }

    private void LoadLeaderboard()
    {
        leaderBoard = db.GetHighscores();
        int i = 0;

        Vector2 myPosition = transform.GetChild(0).GetChild(2).GetChild(1).GetComponent<RectTransform>().anchoredPosition;
        Vector3 myPosition3D = transform.GetChild(0).GetChild(2).GetChild(1).GetComponent<RectTransform>().anchoredPosition3D;
        foreach (Playerscore player in leaderBoard)
        {
            i++;
            myPosition.y = i*0.1F + 0.5F;
            myPosition3D.y -= 40;
            GameObject tempGameObject = Instantiate(Resources.Load("PlayerScore"), transform.GetChild(0).GetChild(2)) as GameObject;
            tempGameObject.GetComponent<RectTransform>().anchoredPosition3D = myPosition3D;
            TextMeshProUGUI name = tempGameObject.transform.GetChild(0).GetComponent<TextMeshProUGUI>();
            TextMeshProUGUI score = tempGameObject.transform.GetChild(1).GetComponent<TextMeshProUGUI>();
            name.SetText(player.Name);
            score.SetText(player.Score.ToString());
            leaderBoardObjects.Add(tempGameObject);

        }
    }
}
